% *******************************************************
%	IHRS design and optimization using Genetic Algorithms 
%	Defining plots to be displayed during optimization
% *******************************************************
%	24.02.00 - last : xx.02.00 by PK
%	PlotSettings.m
% *******************************************************

%	Preliminary assessment of axis ranges of the TBCs versus HR subplot

TBCs_max_approx = ColdUtility(n).c * QC_HC + HotUtility(m).c * Abs_QH_CC;
TBCs_min = 100000 * TBCs_max_approx;	%	used in ROF for improvement history in TBCs mode

HR_max = 0;	%	default initial value used in ROF for improvement history in HR mode
TBCs_vs_HR(1,1:N_HR) = 2.0*TBCs_max_approx;
%delta_HR = HR_max_approx / N_HR;

figure(1)
%	defining the subplots
%	1) the lowest position of(TBCs vs HR) of generated individuals
subplot(3,1,1); axis([0 HR_ul 0 2.0*TBCs_max_approx]); grid on; xlabel('Heat Recovery [kWh/batch]'); ylabel('TBCs [CHF/batch]');	%	location of generated individuals
%	2)the improvements stages
subplot(3,1,2); axis([0 HR_ul 0 2.0*TBCs_max_approx]); grid on; xlabel('Heat Recovery [kWh/batch]'); ylabel('TBCs [CHF/batch]');	%	improvements stages
%	3)the evolution of the best individual and the average "individual" as a function of the number of generations
if HR_mode ==1	%	maximization of HR
   subplot(3,1,3); axis([0 G_SX 0 HR_ul]); grid on; xlabel('Generation [-]'); ylabel('Heat Recovery [kWh/batch]');
else	%	minimization of TBCs
   subplot(3,1,3); axis([0 G_SX 0 2.0*TBCs_max_approx]); grid on; xlabel('Generation [-]'); ylabel('TBCs [CHF/batch]');
end
pause (0.01);

%	end of PlotSettings