% *******************************************************
%	The IHRS project - The EP1 example process
%	Coding Temperature variables.
%
%	Transforming Temperature variables to
%	Reduced T variables used for the GA proceedure
%
% *******************************************************
%	26.01.2000 - last : 01.02.2000 by OW|BR
%	VarInit.m
% *******************************************************

if helppri==1, help VarInit; end
pausetext = 'Press any key ...';

%	Definition of other variables 

%	Case of two-level (SL, XL) optimization
%I_SL = HSULevelParam.I_SL; 
%I_XL = HEXLevelParam.I_XL;
%G_SL = HSULevelParam.G_SL;
%G_XL = HEXLevelParam.G_XL;

%Tk = ones(1,K);	%	operating temperatures of HSUs of "current (SL) individual"
%Tk_I = ones(I_SL+1,K);	% if not managed dynamically by Struggle (or for quick distance measurement), needed to store the Tk vector of "current (SL) population" + candidate offspring
%T  = ones(P,K);	%  T data of process streams of "current (XL) individual"
%T_I = ones(I_XL+1,P,K);	%	if not managed dynamically by Struggle (or for quick distance measurement), needed to store the T matrix of "current (XL) population" + candidate offspring
%X_SL = 0.5*ones(1,K);	%	X independent variables of "current (SL) individual"
%X_I_SL = 0.5*ones(I_SL+1,K);	%	if not managed dynamically by Struggle, to keep trace of "current (SL) population" + candidate offspring
%X_XL  = 0.5*ones(1,P*(K-1));	%	X independent variables of "current (XL) individual", default (maximum) size
%X_I_XL  = 0.5*ones(I_XL+1,P*(K-1));	%	if not managed dynamically by Struggle, to keep trace of "current (SL) population" + candidate offspring, default (maximum) size

%	Case of single level combined SX optimization

I_SX = HSULevelParam.I_SL;	%	use the upper level GA parameters for overall combined SX level optimization
%if Binary_var_mode == 0
%	IV_SX = K + P*(K-1);	%	maximum number of SX independent variables (organized Xk, Xpk) 
%else	%	Binary_var_mode = 1 => P additional variables   
IV_SX = K + P +P*(K-1);	%	maximum number of SX independent variables (organized Xk, Xp, Xpk); Xp generated in any case, irrespective of the value of Binary_var_mode: but shall only be decoded and used if Binary_var_mode = 1 (see beginning of ROF)
%end
G_SX = HSULevelParam.G_SL;
p_m_SX = HSULevelParam.p_m_SL;
p_c_SX = HSULevelParam.p_c_SL;

Xp = ones(1,P);	%	binary variables representing the decision to integrate the stream with HSUs or not (used for Distance)
Tk = ones(1,K);	%	operating temperatures of HSUs of "current (SX) individual"
%Tk_I = ones(I_SX+1,K);	% if not managed dynamically by Struggle (or for quick distance measurement), needed to store the Tk vector of "current (SX) population" + candidate offspring
T  = ones(P,K);	%  T data of process streams of "current (XL) individual"
%T_I = ones(I_SX+1,P,K);	%	if not managed dynamically by Struggle (or for quick distance measurement), needed to store the T matrix of "current (SX) population" + candidate offspring
X_SX = 0.6*ones(1,IV_SX);	%	X (HSU and process streams) independent variables of "current (SX) individual"
X_SX(K+1:K+P) = 1;	%	fixed values of P integer values
X_SX_min = zeros(1,IV_SX);	%	Min of X (HSU and process streams) independent variables
X_SX_min(1:K) =   epsilon_X;	%	Min of X (HSU and process streams) independent variables
X_SX_max =  ones(1,IV_SX);	%	Max of X (HSU and process streams) independent variables
X_SX_max(1:K) = 1-epsilon_X;	%	Max of X (HSU and process streams) independent variables

if QC_HC_tot < Abs_QH_CC_tot
   HR_ul = QC_HC_tot;
else
   HR_ul = Abs_QH_CC_tot;
end
if HR_ul_pinch < HR_ul
   HR_ul = HR_ul_pinch;
end	%	HR_ul is the minimum among QC_HC_tot, Abs_QH_CC_tot, HR_ul_pinch
N_HR = ceil(HR_ul/delta_HR)+1;	%	+1 to include the case when HR=0
TBCs_vs_HR = zeros(4,N_HR);	%	used for statistics of generated individuals, classified as function of HR
Threshold_n_gen = floor(Modified_OF_proportion * G_SX);	%	number of generation at which the OF is changed from the modified to the final OF 



T_Si = [Stream(  1:  J).T_S];
T_Sj = [Stream(I+1:I+J).T_S];
T_Ti = [Stream(  1:  J).T_T];
T_Tj = [Stream(I+1:I+J).T_T];

T_Sp = [Stream.T_S];
T_Tp = [Stream.T_T];

Optional_p = [Stream.optional];

T_min_SF = StorageFluid(1).T_min_SF;
T_max_SF = StorageFluid(1).T_max_SF;
T_min_HSU = max ( T_min_SF, min ( T_Sj ) );
T_max_HSU = min ( T_max_SF, max ( T_Si ) );

DispNum(T_Si,     'T_Si     ',Temp.units);
DispNum(T_Sj,     'T_Sj     ',Temp.units);
DispNum(T_Ti,     'T_Ti     ',Temp.units);
DispNum(T_Tj,     'T_Tj     ',Temp.units);
DispNum(T_min_SF, 'T_min_SF ',Temp.units);
DispNum(T_max_SF, 'T_max_SF ',Temp.units);
DispNum(T_min_HSU,'T_min_HSU',Temp.units);
DispNum(T_max_HSU,'T_max_HSU',Temp.units);

k_max = K * ones(1,P);			%	default initialization
k_min = ones(1,P);				%	default initialization

bad_offspring = 0;
Xpa = [1 1 1 1 0 1 0 1];
Xpb = [1 1 1 1 0 1 1 1];

%	definition of the weighting factor of variables used for the calculation of distance between two individuals

if (Distance_mode == 0)
	%	allocation of the vectors of variables and weights !!!! organized as "Tk", Xp, "Tpk"
   
   Dvar = zeros(1,K+P+(K-1)*P);	%	vector of variables for GA Struggle to calculate the distance
   Dweight = zeros(1,K+P+(K-1)*P)	%	vector of weights to be applied on variable of Dvar to calculate the distance
   
   %	relative weight of HSUs with respect to that of streams
   
   Dweight(1:K) = r_w_Tk_to_T / (T_max_HSU - T_min_HSU);	%	weight of HSU multiplied by r_w_Tk_to_T factor, which could be = 0 (set in InitD), in which case the difference in Tk are not directly taken into account in the distance (while being taken into account through TBCs)
   
	%	search for the maximum usable heat contribution
   
   MCp_dT_max = 0;
	for p = 1:I	%	loop restricted to hot streams
   	q = Stream(p).CP_Dt * (T_Sp(p) - max(T_Tp(p),T_min_HSU));
   	if q > MCp_dT_max
      	MCp_dT_max = q;
   	end
	end
	for p = I+1:P	%	loop restricted to cold streams
   	q = Stream(p).CP_Dt * (T_Sp(p) - min(T_Tp(p),T_max_HSU));	%	Stream(p).CP_Dt < 0 for cold streams, but (T_Sp(p) - min(T_Tp(p),T_max_HSU)) < 0 compensates !!!
   	if q > MCp_dT_max
      	MCp_dT_max = q;
   	end
	end	%	MCp_dT_max is now the greatest heat contribution of process streams (including HR streams)
	for p = 1:P
      Dweight(K+P+1+(K-1)*(p-1):K+P+(K-1)*p) = abs(Stream(p).CP_Dt) / MCp_dT_max;
   end
else	%	Distance_mode = 1
   %	allocation of the vectors of variables and weights 
	Dvar    = zeros(1,K+P+P*K);	%	vector of variables for GA Struggle to calculate the distance
   
   Dweight = ones(1,K+P+P*K);	%	vector of weights to be applied on variable of Dvar to calculate the distance
   %Dweight(K+1:K+P) = 0;	%	default initialization (in case Binary_var_mode = 0, otherwise changed below)
end	%	if Distance_mode

%	definition of the weight of binary variables (if any) - otherwise the weights remain zeros (from initialization above)
%Binary_var_weight = max(Dweight')*(T_max_HSU - T_min_HSU);

%if Binary_var_mode == 1	%	no matter if Distance_mode = 0 or 1 (influence the weight, but the position of the binary variables remains unchanged)
 %  Dweight(K+1:K+P) = Binary_var_weight;
%end
Dweight	%	displays the values

DvarSize = length(Dvar);	%	used in ROF, but unchanged during optimization, hence better to calculate it once and pass it to ROF as global variable


n_gen = 0;					%	default number of generations
n_improvements = 0

	dispnum(G_SX    ,'1 G_SX    ');
	dispnum(NPLOTtot,'1 NPLOTtot');
	dispnum(NGENplot,'1 NGENplot');
if NPLOTtot==0	% !!! particular meaning (unlike common sense) refer to InitD.m
	NGENplot=1
	disp (' WARNING : NPLOTtot=0 ! Plot will be refreshed each generation ! ');
else
	NGENplot = floor(G_SX/NPLOTtot);
end
if NGENplot==0; NGENplot=1; end;	%	should normally not occur if NPLOTtot<=G_SX
	dispnum(G_SX    ,'2 G_SX    ');
	dispnum(NPLOTtot,'3 NPLOTtot');
   dispnum(NGENplot,'4 NGENplot');
   
if interpri > 0
	disp(' ');
	disp(' ');
	disp ( ' Process temperature matrices (k = 1:K) ' );
	disp(' ');
	disp ( [ ' Tk(:)         ', num2str(Tk(:)',3), '  ', Temp.units ] );
	disp(' ');
	for p=1:P
		disp ( [ ' T(:,', num2str(p,2), ')        ', num2str(T(p,:),3), '  ', Temp.units ] );
	end
	disp(' ');
	disp ( ' Reduced temperature matrices (k = 1:K) ' );
	disp(' ');
	disp ( [ ' Xk(:)         ', num2str(Xk(:)',3) ] );
	disp(' ');
	for p=1:P
		disp ( [ ' X(:,', num2str(p,2), ')        ', num2str(X(p,:),3) ] );
	end
end

disp(' ');
disp ( ' End of Program --- VarInit !' );
% ***************************************************