//////////////////////////////////////////////////////////////////////
// MLGAMain.h: interface for the MLGAMain class.
//
// Purpose this class is to be used to as main interface between 
// galib and mathlab. The main mexFunction must be compiled as a DLL
// with a MLGAMain object an the source must provide the later functions
//
// CalcObjective	Objective function
// my_comparator	Compare genomes 
// simul_OF_
// init_OF_			Init genome (first one)
//
// For lanching the program you have to pass the ML arguments to Main
// the arguments are
//
//	input :
//	UserData		as structure
//	Parameters		as structure
//	ControlData		as structure 
//
//	output :
//	BestGenome		as structure similar to User data
//	Plus some functions in one array :
//	Best Obj func	cost1	as double
//	Best Obj func	cost2	as double
//	Best Obj func	cost3	as double
//	Best Obj func	as double
//	Aver Obj func	as double
//	HR Best result	as double
//	Other Best result as double
//  ...
//
// For the structure names see MLInterface.h
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MLGAMAIN_H__7831B461_527D_11D4_8F70_CFC1BC5D6C5D__INCLUDED_)
#define AFX_MLGAMAIN_H__7831B461_527D_11D4_8F70_CFC1BC5D6C5D__INCLUDED_

#include "StruggleH.h"
#include "MixedGenome.h"
#include "MLEvalData.h"
#include "MLInterface.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class MLGAMain  
{
public:
				MLGAMain();
	virtual		~MLGAMain();
	double		Calculate(
					double **PP_SideFun,
					int    *PP_SideFunNum,
					MLInterface *UserData,
					MLInterface *Parametres,
					MLInterface *ControlData);
	void		Main(
					int nlhs,
					mxArray *plhs[],
					int nrhs,
					const mxArray *prhs[] );

private:
	void		print_genome(ostream &ff,GAGenome& g,MLInterface *d);
	void		PrintParList( GAParameterList& ParList );
	void		write_pop(ostream &fname,
					StruggleHGA *ga,
					int ArraySize);

	void		NewParam(GAParameterList *p,
					MLInterface *Parameters);
	MLIO		MlIo;
};

// The functions provided by user
float			CalcObjective(GAGenome& g); 
float			my_comparator(const GAGenome& g1, const GAGenome& g2);
void			simul_OF_ (double *CurrentGenome,int TailleGenome,GAGenome& g,double *OBJ);
void			init_OF_ (double *CurrentGenome,double *InitialGenome, int TailleGenome);

#endif // !defined(AFX_MLGAMAIN_H__7831B461_527D_11D4_8F70_CFC1BC5D6C5D__INCLUDED_)
