//////////////////////////////////////////////////////////////////////
// MLIO.h: interface for the MLIO class.
//
// This is the main I/O class for the MLGAMain and mixedgenome modules
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MLIO_H__505120C1_5BFB_11D4_8F70_BE0664F7C350__INCLUDED_)
#define AFX_MLIO_H__505120C1_5BFB_11D4_8F70_BE0664F7C350__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class MLIO  
{
public:
	MLIO();
	virtual ~MLIO();

	static void PrintTrace(int Value)
		{
		m_PrintTrace = Value;
		}

	static int PrintTrace()
		{
		return m_PrintTrace;
		}

	static void BCO_name(char* Value)
		{
		m_BCO_name = Value;
		}

	static char* BCO_name()
		{
		return m_BCO_name;
		}

	static void BCO_Bmut(float Value)
		{
		m_BCO_Bmut = Value;
		}

	static float BCO_Bmut()
		{
		return m_BCO_Bmut;
		}

	static void BCO_Idep(float Value)
		{
		m_BCO_Idep = Value;
		}

	static float BCO_Idep()
		{
		return m_BCO_Idep;
		}

	static void BCO_Rdep(float Value)
		{
		m_BCO_Rdep = Value;
		}

	static float BCO_Rdep()
		{
		return m_BCO_Rdep;
		}

private:
	static int    m_PrintTrace;			// state of PrinTrace parameter
	static char*  m_BCO_name;			// state of BlendCrossover name parameter
	static double m_BCO_Bmut;			// state of BlendCrossover mutation parameter for binary genes
	static double m_BCO_Idep;			// state of BlendCrossover deployment parameter for integer genes
	static double m_BCO_Rdep;			// state of BlendCrossover deployment parameter for real genes

};

#endif // !defined(AFX_MLIO_H__505120C1_5BFB_11D4_8F70_BE0664F7C350__INCLUDED_)
